gc()
.libPaths("/home2/ghenry/R/x86_64-pc-linux-gnu-library/3.4")
library(methods)
library(readr)
library(Matrix)
library(Seurat)

setwd("../")
genes <- read_delim("./analysis/DATA/genes.tsv","\t",escape_double=FALSE,col_names=FALSE,trim_ws=TRUE)
barcodes <- read_delim("./analysis/DATA/barcodes.tsv","\t",escape_double=FALSE,col_names=FALSE,trim_ws=TRUE)
matrix <- readMM("./analysis/DATA/matrix.mtx")
load("./analysis/DATA/sc10x.data.Rda")

sc10x.Group <- SetAllIdent(object=sc10x.Group,id="SubClust.ID+NE")
barcodes.NE <- names(sc10x.Group@ident[sc10x.Group@ident=="NE"])

genes.rnd <- 1:nrow(genes)
#genes.rnd <- sample(genes.rnd,2500)

barcodes.rnd <- 1:nrow(barcodes)
barcodes.NE.index <- c()
for (i in 1:length(barcodes.NE)){
  barcodes.NE.index <- c(barcodes.NE.index,which(barcodes==barcodes.NE[i]))
}
barcodes.rnd <- barcodes.rnd[!barcodes.rnd %in% barcodes.NE.index]
barcodes.rnd <- sample(barcodes.rnd,(2500-length(barcodes.NE)))
barcodes.rnd <- c(barcodes.rnd,barcodes.NE.index)

genes.sample <- genes[genes.rnd,]
barcodes.sample <- barcodes[barcodes.rnd,]
matrix.sample <- matrix[genes.rnd,barcodes.rnd]

if (!dir.exists("./analysis/CI.TestData.downsample")){
  dir.create("./analysis/CI.TestData.downsample")
}
if (!dir.exists("./analysis/CI.TestData.downsample/10x")){
  dir.create("./analysis/CI.TestData.downsample/10x")
}
if (!dir.exists("./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex")){
  dir.create("./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex")
}
if (!dir.exists("./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex/GRCh38")){
  dir.create("./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex/GRCh38")
}

write.table(genes.sample,file="./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex/GRCh38/genes.tsv",row.names=FALSE,col.names=FALSE,append=FALSE,sep="\t",quote=FALSE)
write.table(barcodes.sample,file="./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex/GRCh38/barcodes.tsv",row.names=FALSE,col.names=FALSE,append=FALSE,sep="\t",quote=FALSE)
writeMM(matrix.sample,file="./analysis/CI.TestData.downsample/10x/filtered_gene_bc_matrices_mex/GRCh38/matrix.mtx")
